#include <dht.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(1, 2, 4, 5, 6, 7, 8, 9, 10, 11);

dht DHT; //create DHT object

int humidityPin = A0; // Analog Pin sensor is connected to
int moisturePin = A1; 
float moistureValue = 0;
float moisture; 
int waterLevelPin = A3;
int waterValue;
int waterLevelValue;

void setup() {
//Serial.begin(9600);
//   
//   //humidity sensor
//  delay(500);//Delay to let system boot
//  Serial.println("DHT11 Humidity & temperature Sensor\n\n");
  delay(1000);//Wait before accessing Sensor

  

}

void loop() {
  humidity();
  moistureSensor();
  waterLevel();
  lcd.begin(16,2);
  lcd.print("Humidity:"); // Prints "Arduino" on the LCD
  delay(1000); // 3 seconds delay
  lcd.setCursor(0,1);
  lcd.print(DHT.humidity);
  lcd.setCursor(5,1);
  lcd.print("%");
  delay(3000);
  lcd.clear(); // Clears the display
  lcd.print("Temperature:"); // Prints "Arduino" on the LCD
  delay(1000); // 3 seconds delay
  lcd.setCursor(0,1);
  lcd.print(DHT.temperature);
  lcd.setCursor(5,1);
  lcd.print(" C");
  delay(3000);
  lcd.clear(); // Clears the display
  lcd.print("Soil moisture"); // Prints "Arduino" on the LCD
  delay(1000); // 3 seconds delay
  lcd.setCursor(0,1);
  lcd.print(moisture);
  lcd.setCursor(5,1);
  lcd.print("%");
  delay(3000);
  lcd.clear(); // Clears the display
  lcd.print("Water level"); // Prints "Arduino" on the LCD
  delay(1000); // 3 seconds delay
  lcd.setCursor(0,1);
  lcd.print(waterLevelValue);
  delay(3000);
  lcd.clear(); // Clears the display

}

void humidity(){
     DHT.read11(humidityPin);
    
    
    delay(1000);//Wait 5 seconds before accessing sensor again.
}

void moistureSensor(){
  for (int i = 0; i <= 100; i++) 
 { 
   moistureValue = moistureValue + analogRead(moisturePin); 
   delay(1); 
 } 
 moistureValue = moistureValue/100.0;
 moisture= map(moistureValue, 15,60,100,0); 
 Serial.print(moistureValue);
 Serial.print("The moisture level of your plant is:");
 Serial.print(moisture);
 Serial.println("%"); 
 delay(50); 
}

void waterLevel(){
   waterValue = analogRead(waterLevelPin);
  if (waterValue < 705) {
    waterLevelValue = 0;
  }
  else if (waterValue >= 705 and waterValue < 712) {
    waterLevelValue = 1;
  }
  else if (waterValue >= 712 and waterValue < 720) {
    waterLevelValue = 2;
  }
  else if (waterValue >= 720) {
    waterLevelValue = 3;
  }

  Serial.println("Waterlevel is:");
   Serial.println(waterLevelValue);
  delay(1000);
}

void LCD(){
 lcd.print("Current humidity:"); // Prints "Arduino" on the LCD
  delay(3000); // 3 seconds delay
  lcd.clear(); // Clears the display
  lcd.print("10");
  delay(3000);
  lcd.clear(); // Clears the display
}
